searchNodes=[{"doc":"This module contains the notify macro and context function you can use in your applications.ConfiguringBy default the HONEYBADGER_API_KEY environment variable is used to find your API key for Honeybadger. You can also manually set your API key by configuring the :honeybadger application. You can see the default configuration in the default_config/0 private function at the bottom of this file.config :honeybadger, api_key: &quot;mysupersecretkey&quot;, environment_name: :prod, app: :my_app_name, exclude_envs: [:dev, :test], breadcrumbs_enabled: true, ecto_repos: [MyAppName.Ecto.Repo], hostname: &quot;myserver.domain.com&quot;, origin: &quot;https://api.honeybadger.io&quot;, proxy: &quot;http://proxy.net:PORT&quot;, proxy_auth: {&quot;Username&quot;, &quot;Password&quot;}, project_root: &quot;/home/skynet&quot;, revision: System.get_env(&quot;GIT_REVISION&quot;), use_logger: true, notice_filter: Honeybadger.NoticeFilter.Default, filter: Honeybadger.Filter.Default, filter_keys: [:password, :credit_card]NotifyingIf you use Honeybadger.Plug and Honeybadger.Logger included in this library you won't need to use Honeybadger.notify/2 for manual reporting very often. However, if you need to send custom notifications you can do so:try do raise RunTimeError, message: &quot;Oops&quot; rescue exception -&gt; context = %{user_id: 1, account: &quot;A Very Important Customer&quot;} Honeybadger.notify( exception, metadata: context, stacktrace: __STACKTRACE__, fingerprint: &quot;user-1&quot; ) endNote that notify may be used outside of try, but it will use a different mechanism for getting the current stacktrace. The resulting stacktrace may be noisier and less accurate.Setting ContextYou can add an arbitrary map of context that will get sent to the Honeybadger API when/if an exception occurs in that process. Do keep in mind the process dictionary is used for retrieving this context so try not to put large data structures in the context.Honeybadger.context(user_id: 1, account: &quot;My Favorite Customer&quot;) Honeybadger.context(%{user_id: 2, account: &quot;That Needy Customer&quot;)Using the PlugIf you're using Phoenix, or any Plug-based Elixir web framework, you can use the Honeybadger.Plug module in your Router and all exceptions in web requests will automatically be reported to Honeybadger.defmodule MoneyPrinter.Router do use MoneyPrinter.Web, :router use Honeybadger.Plug endYou can also automatically set useful context on every request by defining a Plug compatible function:defmodule MoneyPrinter.Router do use MoneyPrinter.Web, :router use Honeybadger.Plug plug :set_honeybadger_context # your routes defp set_honeybadger_context(conn, _opts) do user = get_user(conn) Honeybadger.context(user_id: user.id, account: user.account) conn end endUsing the Error LoggerBy default the logger is enabled. The logger will automatically receive any error reports for SASL compliant processes such as GenServers, GenEvents, Agents, Tasks and any process spawned using proc_lib. You can disable the logger by setting use_logger to false in your Honeybadger config.Using a Notification FilterBefore data is sent to Honeybadger, it is run through a filter which can remove sensitive fields or do other processing on the data. For basic filtering the default configuration is equivalent to:config :honeybadger, filter: Honeybadger.Filter.Default, filter_keys: [:password, :credit_card]This will remove any entries in the context, session, cgi_data and params that match one of the filter keys. The check is case insensitive and matches atoms or strings.If the Filter.Default does not suit your needs, you can implement your own filter. A simple filter looks like:defmodule MyApp.MyFilter do use Honeybadger.Filter.Mixin # drop password fields out of the context Map def filter_context(context), do: Map.drop(context, [:password]) # remove secrets from an error message def filter_error_message(message), do: Regex.replace(~r/Secret: w+/, message, &quot;Secret: ***&quot;) endSee Honeybadger.Filter for details on implementing your own filter.BreadcrumbsBreadcrumbs allow you to record events along a processes execution path. If an error is thrown, the set of breadcrumb events will be sent along with the notice. These breadcrumbs can contain useful hints while debugging.Breadcrumbs are stored in the logger context, referenced by the calling process. If you are sending messages between processes, breadcrumbs will not transfer automatically. Since a typical system might have many processes, it is advised that you be conservative when storing breadcrumbs as each breadcrumb consumes memory.See Honeybadger.add_breadcrumb for info on how to add custom breadcrumbs.Automatic BreadcrumbsWe leverage the telemetry library to automatically create breadcrumbs from specific events.PhoenixIf you are using phoenix (&gt;= v1.4.7) we add a breadcrumb from the router start event.EctoWe can create breadcrumbs from Ecto SQL calls if you are using ecto_sql (&gt;= v3.1.0). You also must specify in the config which ecto adapters you want to be instrumented:config :honeybadger, ecto_repos: [MyApp.Repo]","ref":"Honeybadger.html","title":"Honeybadger","type":"module"},{"doc":"Stores a breadcrumb item.Appends a breadcrumb to the notice. Use this when you want to add some custom data to your breadcrumb trace in effort to help debugging. If a notice is reported to Honeybadger, all breadcrumbs within the execution path will be appended to the notice. You will be able to view the breadcrumb trace in the Honeybadger interface to see what events led up to the notice.Breadcrumb with metadataHoneybadger.add_breadcrumb(&quot;email sent&quot;, metadata: %{ user: user.id, message: message }) =&gt; :okBreadcrumb with specified category. This will display a query icon in the interfaceHoneybadger.add_breadcrumb(&quot;ETS Lookup&quot;, category: &quot;query&quot;, metadata: %{ key: key, value: value }) =&gt; :ok","ref":"Honeybadger.html#add_breadcrumb/2","title":"Honeybadger.add_breadcrumb/2","type":"function"},{"doc":"Clears the context.Note that because context is stored as logger metadata, clearing the context will clear all metadata.","ref":"Honeybadger.html#clear_context/0","title":"Honeybadger.clear_context/0","type":"function"},{"doc":"Retrieves the context that will be sent to the Honeybadger API when an exception occurs in the current process.Context is stored as Logger metadata, and is in fact an alias for Logger.metadata/0.","ref":"Honeybadger.html#context/0","title":"Honeybadger.context/0","type":"function"},{"doc":"Store additional context in the process metadata.This function will merge the given map or keyword list into the existing metadata, with the exception of setting a key to nil, which will remove that key from the metadata.Context is stored as Logger metadata.","ref":"Honeybadger.html#context/1","title":"Honeybadger.context/1","type":"function"},{"doc":"Fetch all configuration specific to the :honeybadger application.This resolves values the same way that get_env/1 does, so it resolves :system tuple variables correctly.ExampleHoneybadger.get_all_env() #=&gt; [api_key: &quot;12345&quot;, environment_name: &quot;dev&quot;, ...]","ref":"Honeybadger.html#get_all_env/0","title":"Honeybadger.get_all_env/0","type":"function"},{"doc":"Fetch configuration specific to the :honeybadger application.ExampleHoneybadger.get_env(:exclude_envs) #=&gt; [:dev, :test]","ref":"Honeybadger.html#get_env/1","title":"Honeybadger.get_env/1","type":"function"},{"doc":"Send an exception notification, if reporting is enabled.This is the primary way to do manual error reporting and it is also used internally to deliver logged errors.StacktraceAccessing the stacktrace outside of a rescue/catch is deprecated. Notifications should happen inside of a rescue/catch block so that the stacktrace can be provided with __STACKTRACE__. Stacktraces must be provided and won't be automatically extracted from the current process.Exampletry do do_something_risky() rescue exception -&gt; Honeybadger.notify(exception, metadata: %{}, stacktrace: __STACKTRACE__) endSend a notification directly from a string, which will be sent as a RuntimeError:iex&gt; Honeybadger.notify(&quot;custom error message&quot;) :okSend a notification as a class and message:iex&gt; Honeybadger.notify(%{class: &quot;SpecialError&quot;, message: &quot;custom message&quot;}) :okSend a notification as a badarg atom:iex&gt; Honeybadger.notify(:badarg) :okIf desired additional metadata can be provided as well:iex&gt; Honeybadger.notify(%RuntimeError{}, metadata: %{culprit_id: 123}) :okIf desired fingerprint can be provided as well:iex&gt; Honeybadger.notify(%RuntimeError{}, fingerprint: &quot;culprit_id-123&quot;) :ok","ref":"Honeybadger.html#notify/1","title":"Honeybadger.notify/1","type":"function"},{"doc":"","ref":"Honeybadger.html#notify/2","title":"Honeybadger.notify/2","type":"function"},{"doc":"","ref":"Honeybadger.html#notify/3","title":"Honeybadger.notify/3","type":"function"},{"doc":"","ref":"Honeybadger.html#t:notify_options/0","title":"Honeybadger.notify_options/0","type":"type"},{"doc":"Specification of user overrideable filter functions.See moduledoc for Honeybadger.Filter.Mixin for details on implementing your own filter.","ref":"Honeybadger.Filter.html","title":"Honeybadger.Filter","type":"behaviour"},{"doc":"Filter breadcrumbs. This filter function receives a list of Breadcrumb structs. You could use any Enum function to constrain the set. Let's say you want to remove any breadcrumb that have metadata that contain SSN:def filter_breadcrumbs(breadcrumbs) do Enum.reject(breadcrumbs, fn breadcrumb -&gt; doMap.has_key?(breadcrumb.metadata, :ssn) end) end","ref":"Honeybadger.Filter.html#c:filter_breadcrumbs/1","title":"Honeybadger.Filter.filter_breadcrumbs/1","type":"callback"},{"doc":"For applications that use Honeybadger.Plug, filter the cgi_data.cgi_data is a map of String.t to String.t which includes HTTP headers and other pre-defined request data (including PATH_INFO, QUERY_STRING, SERVER_PORT etc.).","ref":"Honeybadger.Filter.html#c:filter_cgi_data/1","title":"Honeybadger.Filter.filter_cgi_data/1","type":"callback"},{"doc":"Filter the context Map. The context is a map of application supplied data.","ref":"Honeybadger.Filter.html#c:filter_context/1","title":"Honeybadger.Filter.filter_context/1","type":"callback"},{"doc":"Filter the error message string. This is the message from the most recently thrown error.","ref":"Honeybadger.Filter.html#c:filter_error_message/1","title":"Honeybadger.Filter.filter_error_message/1","type":"callback"},{"doc":"For applications that use Honeybadger.Plug, filters the query parameters. The parameters is a map of String.t to String.t, e.g.:%{&quot;user_name&quot; =&gt; &quot;fred&quot;, &quot;password&quot; =&gt; &quot;12345&quot;}","ref":"Honeybadger.Filter.html#c:filter_params/1","title":"Honeybadger.Filter.filter_params/1","type":"callback"},{"doc":"For applications that use Honeybadger.Plug, filter the session.","ref":"Honeybadger.Filter.html#c:filter_session/1","title":"Honeybadger.Filter.filter_session/1","type":"callback"},{"doc":"The default implementation for the filter configuration. Removes keys listed in filter_keys from maps and respects the filter_disable_* configuration values.","ref":"Honeybadger.Filter.Default.html","title":"Honeybadger.Filter.Default","type":"module"},{"doc":"Callback implementation for Honeybadger.Filter.filter_breadcrumbs/1.","ref":"Honeybadger.Filter.Default.html#filter_breadcrumbs/1","title":"Honeybadger.Filter.Default.filter_breadcrumbs/1","type":"function"},{"doc":"Callback implementation for Honeybadger.Filter.filter_cgi_data/1.","ref":"Honeybadger.Filter.Default.html#filter_cgi_data/1","title":"Honeybadger.Filter.Default.filter_cgi_data/1","type":"function"},{"doc":"Callback implementation for Honeybadger.Filter.filter_context/1.","ref":"Honeybadger.Filter.Default.html#filter_context/1","title":"Honeybadger.Filter.Default.filter_context/1","type":"function"},{"doc":"Callback implementation for Honeybadger.Filter.filter_error_message/1.","ref":"Honeybadger.Filter.Default.html#filter_error_message/1","title":"Honeybadger.Filter.Default.filter_error_message/1","type":"function"},{"doc":"","ref":"Honeybadger.Filter.Default.html#filter_map/2","title":"Honeybadger.Filter.Default.filter_map/2","type":"function"},{"doc":"Callback implementation for Honeybadger.Filter.filter_params/1.","ref":"Honeybadger.Filter.Default.html#filter_params/1","title":"Honeybadger.Filter.Default.filter_params/1","type":"function"},{"doc":"Callback implementation for Honeybadger.Filter.filter_session/1.","ref":"Honeybadger.Filter.Default.html#filter_session/1","title":"Honeybadger.Filter.Default.filter_session/1","type":"function"},{"doc":"A default implementation of Honeybadger.Filter.If you need to implement custom filtering for one or more of the elements in a Honeybadger.Notice, you can define your own filter module and register it in the config. E.g., if you wanted to filter the error message string, but keep all of the other default filtering, you could do:defmoudle MyApp.MyFilter do use Honeybadger.Filter.Mixin def filter_error_message(message) do # replace passwords in error message with `&quot;xxx&quot;` Regex.replace(~r/(password: *)&quot;([^&quot;]+)&quot;/, message, ~s(\\1&quot;xxx&quot;)) end endAnd set the configuration to:config :honeybadger, filter: MyApp.MyFilterSee the documentation for Honeybadger.Filter for a list of functions that may be overridden. The default implementations for all of the functions that take a map are to remove any keys from the map that match a key in filter_keys. The check matches atoms and strings in a case insensitive manner.","ref":"Honeybadger.Filter.Mixin.html","title":"Honeybadger.Filter.Mixin","type":"module"},{"doc":"The callbacks required to implement the FingerprintAdapter behaviour","ref":"Honeybadger.FingerprintAdapter.html","title":"Honeybadger.FingerprintAdapter","type":"behaviour"},{"doc":"This function receives a Honeybadger.Notice.t/0 and must return a string that will be used as a fingerprint for the request:def parse(notice) do notice.notifier.language &lt;&gt; &quot;_&quot; &lt;&gt; notice.notifier.name end","ref":"Honeybadger.FingerprintAdapter.html#c:parse/1","title":"Honeybadger.FingerprintAdapter.parse/1","type":"callback"},{"doc":"","ref":"Honeybadger.Notice.html","title":"Honeybadger.Notice","type":"module"},{"doc":"","ref":"Honeybadger.Notice.html#new/4","title":"Honeybadger.Notice.new/4","type":"function"},{"doc":"","ref":"Honeybadger.Notice.html#t:error/0","title":"Honeybadger.Notice.error/0","type":"type"},{"doc":"","ref":"Honeybadger.Notice.html#t:noticeable/0","title":"Honeybadger.Notice.noticeable/0","type":"type"},{"doc":"","ref":"Honeybadger.Notice.html#t:notifier/0","title":"Honeybadger.Notice.notifier/0","type":"type"},{"doc":"","ref":"Honeybadger.Notice.html#t:server/0","title":"Honeybadger.Notice.server/0","type":"type"},{"doc":"","ref":"Honeybadger.Notice.html#t:t/0","title":"Honeybadger.Notice.t/0","type":"type"},{"doc":"Specification for a top level Honeybadger.Notice filter.Most users won't need this, but if you need complete control over filtering, implement this behaviour and configure like:config :honeybadger, notice_filter: MyApp.MyNoticeFilter","ref":"Honeybadger.NoticeFilter.html","title":"Honeybadger.NoticeFilter","type":"behaviour"},{"doc":"","ref":"Honeybadger.NoticeFilter.html#c:filter/1","title":"Honeybadger.NoticeFilter.filter/1","type":"callback"},{"doc":"","ref":"Honeybadger.NoticeFilter.Default.html","title":"Honeybadger.NoticeFilter.Default","type":"module"},{"doc":"Callback implementation for Honeybadger.NoticeFilter.filter/1.","ref":"Honeybadger.NoticeFilter.Default.html#filter/1","title":"Honeybadger.NoticeFilter.Default.filter/1","type":"function"},{"doc":"The Honeybadger.Plug adds automatic error handling to a plug pipeline.Within a Plug.Router or Phoenix.Router use the module and crashes will be reported to Honeybadger. It's best to use Honeybadger.Plug after the Router plugs so that exceptions due to non-matching routes are not reported to Honeybadger.Exampledefmodule MyPhoenixApp.Router do use Crywolf.Web, :router use Honeybadger.Plug pipeline :browser do [...] end endCustomizingData reporting may be customized by passing an alternate :plug_data module. This is useful when working with alternate frameworks, such as Absinthe for GraphQL APIs.Any module with a metadata/2 function that accepts a Plug.Conn and a module name can be used to generate metadata.Exampledefmodule MyPhoenixApp.Router do use Crywolf.Web, :router use Honeybadger.Plug, plug_data: MyAbsinthePlugData end","ref":"Honeybadger.Plug.html","title":"Honeybadger.Plug","type":"module"},{"doc":"Assorted helper functions used through out the Honeybadger package.","ref":"Honeybadger.Utils.html","title":"Honeybadger.Utils","type":"module"},{"doc":"Transform value into a consistently cased string representationExampleiex&gt; Honeybadger.Utils.canonicalize(:User_SSN) &quot;user_ssn&quot;","ref":"Honeybadger.Utils.html#canonicalize/1","title":"Honeybadger.Utils.canonicalize/1","type":"function"},{"doc":"Internally all modules are prefixed with Elixir. This function removes the Elixir prefix from the module when it is converted to a string.Exampleiex&gt; Honeybadger.Utils.module_to_string(Honeybadger.Utils) &quot;Honeybadger.Utils&quot;","ref":"Honeybadger.Utils.html#module_to_string/1","title":"Honeybadger.Utils.module_to_string/1","type":"function"},{"doc":"Configurable data sanitization. This currently:recursively truncates deep structures (to a depth of 20)constrains large string values (to 64k)filters out any map keys that might contain sensitive information.","ref":"Honeybadger.Utils.html#sanitize/2","title":"Honeybadger.Utils.sanitize/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Honeybadger.Test.html","title":"Mix.Tasks.Honeybadger.Test","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Honeybadger.Test.html#run/1","title":"Mix.Tasks.Honeybadger.Test.run/1","type":"function"},{"doc":"release uses shipit. It performs many sanity checks before pushing the hex package. Check out https://github.com/wojtekmach/shipit for more details","ref":"Mix.Tasks.Release.html","title":"Mix.Tasks.Release","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Release.html#run/1","title":"Mix.Tasks.Release.run/1","type":"function"},{"doc":"","ref":"Honeybadger.MissingEnvironmentNameError.html","title":"Honeybadger.MissingEnvironmentNameError","type":"exception"},{"doc":"","ref":"HoneybadgerTestingException.html","title":"HoneybadgerTestingException","type":"exception"},{"doc":"Honeybadger for ElixirElixir Plug, Logger and client for the :zap: Honeybadger error notifier.Upgrading to v0.11? See the release notes","ref":"readme.html","title":"Honeybadger for Elixir","type":"extras"},{"doc":"&lt;img src=&quot;https://docs-honeybadger.s3.amazonaws.com/elixirsips.jpg&quot; alt=&quot;ElixirSips&quot; width=600/&gt;Watch our screencast by Josh Adams of ElixirSips!","ref":"readme.html#getting-started","title":"Honeybadger for Elixir - Getting Started","type":"extras"},{"doc":"Erlang &gt;= 18.0Elixir &gt;= 1.3Plug &gt;= 1.0Phoenix &gt;= 1.0 (This is an optional dependency and the version requirement applies only if you are using Phoenix)1. Install the packageAdd the Honeybadger package to deps/0 in your application's mix.exs file and run mix do deps.get, deps.compiledefp deps do [{:honeybadger, &quot;~&gt; 0.12&quot;}] end2. Set your API key and environment nameBy default the environment variable HONEYBADGER_API_KEY will be used to find your API key to the Honeybadger API. If you would like to specify your key or any other configuration options a different way, you can do so in config.exs:config :honeybadger, api_key: &quot;sup3rs3cr3tk3y&quot;We also need to set the name of the environment for each environment. This ensures that we can accurately report the environment that an error occurs in. You can add something like the following to each of your \#{env}.exs files:config :honeybadger, environment_name: :devIf environment_name is not set we will fall back to the value of Mix.env(). Mix.env() uses the atomized value of the MIX_ENV environment variable and defaults to :dev when the environment variable is not set. This should be good for most setups. If you want to have an environment_name which is different than the Mix.env(), you should set environment_name in your config.exs files for each environment. This ensures that we can give you accurate environment information even during compile time. Explicitly setting the environment_name config takes higher precedence over the Mix.env() value.3. Enable error reportingThe Honeybadger package can be used as a Plug alongside your Phoenix applications, as a logger backend, or as a standalone client for sprinkling in exception notifications where they are needed.Phoenix and PlugThe Honeybadger Plug adds a Plug.ErrorHandler to your pipeline. Simply use the Honeybadger.Plug module inside of a Plug or Phoenix.Router and any crashes will be automatically reported to Honeybadger. It's best to use Honeybadger.Plug after the Router plugs so that exceptions due to non-matching routes are not reported to Honeybadger.Phoenix appdefmodule MyPhoenixApp.Router do use Crywolf.Web, :router use Honeybadger.Plug pipeline :browser do [...] end endPlug appdefmodule MyPlugApp do use Plug.Router use Honeybadger.Plug [... the rest of your plug ...] endLoggerJust set the use_logger option to true in your application's config.exs and you're good to go! Any SASL compliant processes that crash will send an error report to the Honeybadger.Logger. After the error reaches the logger we take care of notifying Honeybadger for you!Manual reportingYou can manually report rescued exceptions with the Honeybadger.notify function.try do File.read! &quot;this_file_really_should_exist_dang_it.txt&quot; rescue exception -&gt; Honeybadger.notify(exception, metadata: %{}, stacktrace: __STACKTRACE__, fingerprint: &quot;&quot;) end","ref":"readme.html#version-requirements","title":"Honeybadger for Elixir - Version requirements","type":"extras"},{"doc":"Breadcrumbs allow you to record events along a processes execution path. If an error is thrown, the set of breadcrumb events will be sent along with the notice. These breadcrumbs can contain useful hints while debugging.Breadcrumbs are stored in the logger context, referenced by the calling process. If you are sending messages between processes, breadcrumbs will not transfer automatically. Since a typical system might have many processes, it is advised that you be conservative when storing breadcrumbs as each breadcrumb consumes memory.Automatic BreadcrumbsWe leverage the telemetry library to automatically create breadcrumbs from specific events.PhoenixIf you are using phoenix (&gt;= v1.4.7) we add a breadcrumb from the router start event.EctoWe can create breadcrumbs from Ecto SQL calls if you are using ecto_sql (&gt;= v3.1.0). You also must specify in the config which ecto adapters you want to be instrumented:config :honeybadger, ecto_repos: [MyApp.Repo]","ref":"readme.html#breadcrumbs","title":"Honeybadger for Elixir - Breadcrumbs","type":"extras"},{"doc":"If you'd like to see the module in action before you integrate it with your apps, check out our sample Phoenix application.You can deploy the sample app to your Heroku account by clicking this button:Don't forget to destroy the Heroku app after you're done so that you aren't charged for usage.The code for the sample app is available on Github, in case you'd like to read through it, or run it locally.","ref":"readme.html#sample-application","title":"Honeybadger for Elixir - Sample Application","type":"extras"},{"doc":"Before data is sent to Honeybadger, it is passed through a filter to remove sensitive fields and do other processing on the data. The default configuration is equivalent to:config :honeybadger, filter: Honeybadger.Filter.Default, filter_keys: [:password, :credit_card]This will remove any entries in the context, session, cgi_data and params that match one of the filter keys. The filter is case insensitive and matches atoms or strings.If Honeybadger.Filter.Default does not suit your needs, you can implement your own filter. See the Honeybadger.Filter.Mixin module doc for details on implementing your own filter.","ref":"readme.html#filtering-sensitive-data","title":"Honeybadger for Elixir - Filtering Sensitive Data","type":"extras"},{"doc":"You can set configuration options in config.exs. It looks like this:config :honeybadger, api_key: &quot;sup3rs3cr3tk3y&quot;, environment_name: :prodIf you'd rather read, eg., environment_name from the OS environment, you can do like this:config :honeybadger, environment_name: {:system, &quot;HONEYBADGER_ENV&quot;}, revision: {:system, &quot;HEROKU_SLUG_COMMIT&quot;}NOTE: This works only for the string options, and environment_name.Here are all of the options you can pass in the keyword list:NameDescriptionDefaultappName of your app's OTP Application as an atomMix.Project.config[:app]api_keyYour application's Honeybadger API keySystem.get_env(&quot;HONEYBADGER_API_KEY&quot;))environment_name(required) The name of the environment your app is running in.nilexclude_envsEnvironments that you want to disable Honeybadger notifications[:dev, :test]hostnameHostname of the system your application is running on:inet.gethostnameoriginURL for the Honeybadger API&quot;https://api.honeybadger.io&quot;project_rootDirectory root for where your application is runningSystem.cwd/0revisionThe project's git revisionnilfilterModule implementing Honeybadger.Filter to filter data before sending to Honeybadger.ioHoneybadger.Filter.Defaultfilter_keysA list of keywords (atoms) to filter. Only valid if filter is Honeybadger.Filter.Default[:password, :credit_card]filter_argsIf true, will remove function arguments in backtracestruefilter_disable_urlIf true, will remove the request urlfalsefilter_disable_sessionIf true, will remove the request sessionfalsefilter_disable_paramsIf true, will remove the request paramsfalsefingerprint_adapterImplementation of FingerprintAdapter behaviournotice_filterModule implementing Honeybadger.NoticeFilter. If nil, no filtering is done.Honeybadger.NoticeFilter.Defaultuse_loggerEnable the Honeybadger Logger for handling errors outside of web requeststrueignored_domainsAdd domains to ignore Error events in Honeybadger.Logger.[:cowboy]breadcrumbs_enabledEnable breadcrumb event trackingfalseecto_reposModules with implemented Ecto.Repo behaviour for tracking SQL breadcrumb events[]","ref":"readme.html#advanced-configuration","title":"Honeybadger for Elixir - Advanced Configuration","type":"extras"},{"doc":"Honeybadger.notify: Send an exception to Honeybadger.Use the Honeybadger.notify/2 function to send exception information to the collector API. The first parameter is the exception and the second parameter is the context/metadata/fingerprint. There is also a Honeybadger.notify/1 which doesn't require the second parameter.Examples:try do File.read! &quot;this_file_really_should_exist_dang_it.txt&quot; rescue exception -&gt; context = %{user_id: 5, account_name: &quot;Foo&quot;} Honeybadger.notify(exception, metadata: context, stacktrace: __STACKTRACE__) endHoneybadger.context/1: Set metadata to be sent if an error occursHoneybadger.context/1 is provided for adding extra data to the notification that gets sent to Honeybadger. You can make use of this in places such as a Plug in your Phoenix Router or Controller to ensure useful debugging data is sent along.Examples:def MyPhoenixApp.Controller use MyPhoenixApp.Web, :controller plug :set_honeybadger_context def set_honeybadger_context(conn, _opts) do user = get_user(conn) Honeybadger.context(user_id: user.id, account: user.account.name) conn end endHoneybadger.context/1 stores the context data in the process dictionary, so it will be sent with errors/notifications on the same process. The following Honeybadger.notify/1 call will not see the context data set in the previous line.Honeybadger.context(user_id: 5) Task.start(fn -&gt; # this notify does not see the context set earlier # as this runs in a different elixir/erlang process. Honeybadger.notify(%RuntimeError{message: &quot;critical error&quot;}) end)Honeybadger.add_breadcrumb/2: Store breadcrumb within processAppends a breadcrumb to the notice. Use this when you want to add some custom data to your breadcrumb trace in effort to help debugging. If a notice is reported to Honeybadger, all breadcrumbs within the execution path will be appended to the notice. You will be able to view the breadcrumb trace in the Honeybadger interface to see what events led up to the notice.Examples:Honeybadger.add_breadcrumb(&quot;Email sent&quot;, metadata: %{ user: user.id, message: message })","ref":"readme.html#public-interface","title":"Honeybadger for Elixir - Public Interface","type":"extras"},{"doc":"If your server needs a proxy to access honeybadger, add the following to your configconfig :honeybadger, proxy: &quot;url&quot;, proxy_auth: {&quot;username&quot;, &quot;password&quot;}","ref":"readme.html#proxy-configuration","title":"Honeybadger for Elixir - Proxy configuration","type":"extras"},{"doc":"Set the HONEYBADGER_API_KEY as documented aboveRemove :dev from the exclude_envs by adding this to your config/dev.exsconfig :honeybadger, exclude_envs: [:test]Run the mix honeybadger.test mix task task to simulate an error","ref":"readme.html#testing-your-honeybadger-setup-in-dev","title":"Honeybadger for Elixir - Testing your Honeybadger setup in dev","type":"extras"},{"doc":"See https://github.com/honeybadger-io/honeybadger-elixir/blob/master/CHANGELOG.md","ref":"readme.html#changelog","title":"Honeybadger for Elixir - Changelog","type":"extras"},{"doc":"If you're adding a new feature, please submit an issue as a preliminary step; that way you can be (moderately) sure that your pull request will be accepted.To contribute your code:Fork it.Create a topic branch git checkout -b my_branchCommit your changes git commit -am &quot;Boom&quot;Update the ChangelogPush to your branch git push origin my_branchSend a pull requestPublishing a release on hex.pmMake sure you have the following dependencies, and tests pass locally and in CI:mix deps.get mix archive.install hex shipit mix testUpdate the version property in mix.exsCreate a git commit with all the changes so that your working directory is cleanRun mix shipit BRANCH VERSION from your terminal, which will do the following:Upload the new version of honeybadger to hex.pmCreate a git tag with the version number and push it to GitHubLicenseThis library is MIT licensed. See the LICENSE file in this repository for details.","ref":"readme.html#contributing","title":"Honeybadger for Elixir - Contributing","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file. See Keep a CHANGELOG for how to update this file. This project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"ChangedSend notifications on error-level logsAdded ignored_domain config with [:cowboy] as default","ref":"changelog.html#v0-16-0-2021-02-22","title":"Changelog - [v0.16.0] - 2021-02-22","type":"extras"},{"doc":"AddedNew fingerprint option and config for Honeybadger.notify/2. Thanks @brunozrk! (#305)","ref":"changelog.html#v0-15-0-2020-09-24","title":"Changelog - [v0.15.0] - 2020-09-24","type":"extras"},{"doc":"FixedImplement Jason.Encoder for RingBuffer (#294)","ref":"changelog.html#v0-14-1-2020-07-06","title":"Changelog - [v0.14.1] - 2020-07-06","type":"extras"},{"doc":"ChangedBreadcrumbs on by default","ref":"changelog.html#v0-14-0-2020-03-12","title":"Changelog - [v0.14.0] - 2020-03-12","type":"extras"},{"doc":"FixedSafely sanitize invalid binaries when encoding JSON for notices.Fixes for Elixir 1.10 release (#259)","ref":"changelog.html#v0-13-1-2020-02-06","title":"Changelog - [v0.13.1] - 2020-02-06","type":"extras"},{"doc":"AddedIntroducing Breadcrumbs (#235)! After enabling in the config with breadcrumbs_enabled: true, just call Honeybadger.add_breadcrumb/2 anywhere in your code and if an error is reported in that process, the breadcrumb event will be passed along with the Notice.ChangedRenamed Notifier to honeybadger-elixir and added language","ref":"changelog.html#v0-13-0-2019-10-02","title":"Changelog - [v0.13.0] - 2019-10-02","type":"extras"},{"doc":"FixedCall Exception.blame/3 after normalizing string errors, which prevents reporint all string messages as Erlang errors. (#225)","ref":"changelog.html#v0-12-1-2019-06-12","title":"Changelog - [v0.12.1] - 2019-06-12","type":"extras"},{"doc":"AddedAdded :revision configuration optionAutomatically call Exception.blame/3 to record additional information in the exception","ref":"changelog.html#v0-12-0-2019-05-30","title":"Changelog - [v0.12.0] - 2019-05-30","type":"extras"},{"doc":"When upgrading to v0.11, users should be aware of a few important changes:You must be on Elixir 1.7+ and Erlang/OTP 21+Due to the deprecation of System.stacktrace/0 and the introduction of __STACKTRACE__, manually calling Honeybadger.notify/3 will no longer include a stacktrace by default. See the issue discussion for more detailsA stacktrace can be manually provided from within a rescue/catch block via the STACKTRACE macro, e.g. Honeybadger.notify(SomeError, %{my: :context}, __STACKTRACE__)ChangedSwitch from Erlang's :error_logger to an Elixir 1.7 and Erlang/OTP 21+ Logger backend. This provides more consistent error reporting and enhanced integration with Logger metadata.Stop automatically extracting stacktraces for calls to Honeybadger.notice/3. The generated stacktrace was unreliably and frequently listed the Honeybadger reporter's internals, rather than application code. Manual calls to notice/3 should happen within a rescue/catch block and use the __STACKTRACE__ macro.AddedUse Logger.metadata as the basis for Honeybadger context in all logger generated noticesFixedFix Map.t() isn't a valid dialyzer type (#198)Try to convert remote IP to string in case of parsing failure","ref":"changelog.html#v0-11-0-2019-02-28","title":"Changelog - [v0.11.0] - 2019-02-28","type":"extras"},{"doc":"FixedPrevent crashes reporting :badmatch when fetching the current stacktrace from a dead process.Updated dependencies.","ref":"changelog.html#v0-10-3-2018-07-02","title":"Changelog - [v0.10.3] - 2018-07-02","type":"extras"},{"doc":"FixedFix crashes caused by presence of structs in the context.","ref":"changelog.html#v0-10-2-2018-07-02","title":"Changelog - [v0.10.2] - 2018-07-02","type":"extras"},{"doc":"ChangedHandle fetching peer info when using Plug 1.6. This is implemented in a backward compatible manner, so versions &lt; 1.6 will continue to work.FixedFetch peer information for multiple plug versionsBump phoenix from 1.3.2 to 1.3.3Bump hackney from 1.12.1 to 1.13.0","ref":"changelog.html#v0-10-1-2018-06-27","title":"Changelog - [v0.10.1] - 2018-06-27","type":"extras"},{"doc":"ChangedReplace Poison with Jason for JSON encoding.Reduce the log level used for dev mode warning.Update dependenices.Fixed JSON encoding error.Send notifications even when the stacktrace isn't a list. Errors reported from the error logger can occasionally have a malformed stacktrace, which would raise another exception and prevent the notification from being sent.","ref":"changelog.html#v0-10-0-2018-05-29","title":"Changelog - [v0.10.0] - 2018-05-29","type":"extras"},{"doc":"ChangedUse lazy logging within Honeybadger.Client, this allows compile time purging when the log level is set higher.FixedFix a regression which was causing Not Found (404) errors to be reported.Fix an issue caused by hackney because of unread response bodies.","ref":"changelog.html#v0-9-0-2018-03-21","title":"Changelog - [v0.9.0] - 2018-03-21","type":"extras"},{"doc":"AddedInclude function arity in notice backtraces. For example, the reported method would be notify/3 instead of notify.Include function arguments in notice backtraces. This is disabled by default, and can be enabled by setting filter_args to false in configuration.ChangedAllow handle_errors from Honeybadger.Plug to be overridden.FixedSafely convert binary :environment_name values to an atom. If the environment was specified via {:system, &quot;HONEYBADGER_ENV&quot;} and the HONEYBADGER_ENV value didn't already exist as an atom the app would fail to boot.Ignore the absence of HONEYBADGER_API_KEY when running in an excluded env","ref":"changelog.html#v0-8-0-2018-01-17","title":"Changelog - [v0.8.0] - 2018-01-17","type":"extras"},{"doc":"AddedIncreases the logging around client activity (honeybadger-io/honeybadger-elixir#20).Explicitly allow sending notices with strings and maps. For example, it is now possible to send a RuntimeError by calling Honeybadger.notify(&quot;oops!&quot;).Added Honeybadger test mix task which can be invoked using mix honeybadger.testChangedSwitch from GenEvent to implementing gen_event behaviour.Remove error_logger backend on application stop.Use the latest exception's stacktrace whenever notify is called from a try expression.Namespace modules related to Filter and NoticeFilter. This is largely an internal restructuring, but any custom filters that used the Honeybadger.FilterMixin will need to specify Honeybadger.Filter.Mixin instead.Drops HTTPoison in favor of directly using Hackney, which gives us access to a connection pool.Drops Meck and stubbing in favor of a local cowboy server (honeybadger-io/honeybadger-elixir#7).Starts a supervision tree with the client as a child.Report the controller and action name as component and action for phoenix appsFixedFiltering CGI data now respects the filter_disable_url setting. All path related fields (ORIGINAL_FULLPATH, QUERY_STRING, PATH_INFO) are filtered now.Get the environment directly from Mix.env and always compare the environment names as atoms (honeybadger-io/honeybadger-elixir#94).Changes notify from a macro to a function.Stops spawning new tasks for every error, instead relying on async handling in the client (honeybadger-io/honeybadger-elixir#88).","ref":"changelog.html#v0-7-0-2017-11-07","title":"Changelog - [v0.7.0] - 2017-11-07","type":"extras"},{"doc":"ChangedRemoves metrics reporting.FixedLoosens httpoison dependency.Misc. bug fixes.","ref":"changelog.html#0-6-3-2017-05-04","title":"Changelog - [0.6.3] - 2017-05-04","type":"extras"},{"doc":"Addedability to customize error names/messages,Fixedstops plug error notifications from being sent twiceminor typo fixesdependency updates","ref":"changelog.html#0-6-2-2016-10-24","title":"Changelog - [0.6.2] - 2016-10-24","type":"extras"},{"doc":"FixedReformatting the plug environment data sent to Honeybadger.","ref":"changelog.html#0-6-1-2016-08-02","title":"Changelog - [0.6.1] - 2016-08-02","type":"extras"},{"doc":"FixedThis release removes warnings for Elixir 1.3.0 and covers v1.4.0-dev as of 2016-07-22. There was also a switch to using :native FromUnits to match the Plug.Logger usage of :erlang.convert_time_unit. This maintains consistency between Honeybadger.Logger and Plug.Logger.","ref":"changelog.html#0-6-0-2016-07-22","title":"Changelog - [0.6.0] - 2016-07-22","type":"extras"},{"doc":"AddedHoneybadger now collects successful response times, aggregates them and sends them to the Honeybadger API! You can see request metric data from the metrics tab on Honeybadger.io!","ref":"changelog.html#0-5-0-2016-04-26","title":"Changelog - [0.5.0] - 2016-04-26","type":"extras"},{"doc":"ChangedDue to the Mix.env/0 function always being set to prod for dependencies and Mix being compiled out of applications by exrm, we now require you to explicitly declare your environment_name for every environment in your config.exs files.Example: # config/dev.exs config :honeybager, environment_name: :devDoing this will ensure you get accurate environment information for exceptions that happen at runtime as well as compile time. You can also set the environment_name setting a MIX_ENV environment variable.Example: $ MIX_ENV=prod mix phoenix.serverNote: setting environment_name in your config files takes higher precedence than the MIX_ENV environment variable.","ref":"changelog.html#0-4-0-2016-02-23","title":"Changelog - [0.4.0] - 2016-02-23","type":"extras"},{"doc":"FixedFix a bug where notifications reported by the error_logger were not sending the the context","ref":"changelog.html#0-3-1-2016-02-04","title":"Changelog - [0.3.1] - 2016-02-04","type":"extras"}]